﻿// Copyright (c) 2020 Tudor Stanciu

namespace Tuitio.PublishedLanguage.Dto
{
    public class Envelope<T> where T : class
    {
        public T Result { get; }
        public string Error { get; }

        public Envelope(T result, string error)
        {
            Result=result;
            Error=error;
        }

        public static Envelope<T> Success(T result)
        {
            return new Envelope<T>(result, null);
        }

        public static Envelope<T> Fail(string message)
        {
            return new Envelope<T>(null, message);
        }
    }
}
